import sys
sys.path.append('../..')
import os

import conf
from mupif import Application
from mupif import APIError
from mupif import PyroUtil
import time as timeTime


start = timeTime.time()
#locate nameserver
ns = PyroUtil.connectNameServer(conf.nshost, 9090, conf.hkey)

results=[]
apprecord = 'celsian'
starti = timeTime.time()
conf.logger.info("Trying to connect to server " + str(apprecord[conf.appIndx_Name]))
try:
    tunnel = PyroUtil.sshTunnel('192.168.16.6', userName='smilauer', 
                                localPort=5555, remotePort=44381,
                                sshClient='ssh', options='-oStrictHostKeyChecking=no -p 223 -i /home/smilauer/.ssh/Luuk-Celsian/smilauer.openssh.ppk', sshHost='remote.celsian.nl')

    # connect to individual applications
    app = PyroUtil.connectApp(ns, PyroUtil.getNSAppName('PingTest','celsian'))
    if app:
        appsig=app.getApplicationSignature()
        msg = "Successfully connected to %-30s (%4.2f s)"%(appsig, timeTime.time()-starti)
        conf.logger.info(msg)
        conf.logger.info("Time elapsed %f s" % (timeTime.time()-starti) )
    else:
        msg = "Unable to connect to " + str(apprecord[conf.appIndx_Name])
        conf.logger.error(msg)
    results.append(msg)
finally:
    conf.logger.debug("Closing ssh tunnel")
    if tunnel: tunnel.terminate()

print ("=========SUMMARY============")
for r in results:
    print (r)


print ("Total time consumed %f s" % (timeTime.time()-start))
print ("Ping test finished")
